
import java.util.*;

public class BoundedBuffer {

    private Vector buffer;
    private Semaphore full;
    private Semaphore empty;
    private int size;
    private Object putSync;
    private Object getSync;

    public BoundedBuffer(int s) {
        buffer = new Vector();
        size = s;
        full = new Semaphore( 0 );
        empty = new Semaphore( s );
        putSync = new Object();
        getSync = new Object();
    }

    public void put(Object o) throws InterruptedException {
        empty.down();
        synchronized (putSync) { buffer.add(o); }
        full.up();
    }

    public Object get() throws InterruptedException {
        Object o;
        full.down();
	synchronized (getSync) { o = buffer.remove(0); }
        empty.up();
	return o;
    }

    public boolean empty() {
        return !full.isPositive();
    }

}
