/** 
 * Parallel QuickSort 
 *
 * see Cormen+
 *
 */

//package edu.unima.ky.parallel;

import java.io.*;

public class ParQuickSort extends RecursionTask {

    private static int[] A;
    private int l, r;

    private static int thresh = 1000;
    private int numwork = 4;
    private static RecursionThreads workers = null;

    public ParQuickSort(int ll, int rr) {
        l = ll;
        r = rr;
    }

    public ParQuickSort(int[] A) {
        this.A = A;
        l = 0;
        r = A.length - 1;
            System.out.println(numwork + " workers created");
        numwork = Math.min( numwork, r / thresh );
            System.out.println(numwork + " workers created");
        if ( workers == null ) {
	    workers = new RecursionThreads( numwork );
	}
    }


    public synchronized void sort() {
        workers.invoke(this);
	System.out.println(" terminating ");
        workers.terminate(); 
        workers = null;
        //cormenQuicksort(0,A.length-1);
	return;
    }


    public void compute() {
        cormenQuicksort(l,r);
	System.out.println("computed l " + l + " r " + r);
	return;
    }


    private int partition(int l, int r) {
	// if (l >= r) return l;
	int x, t, i, j;
        x = A[l]; i = l-1; j = r+1;
        while (true) {
	    do { j--; } while ( A[j] > x );
	    do { i++; } while ( A[i] < x );
            if ( i < j ) {
               t = A[i]; A[i] = A[j]; A[j] = t; 
            } else return j;
        }
    }

    private void cormenQuicksort(int l, int r) {
	if (l >= r) return;
	int q = partition(l,r);

        // sequential recursion
        if ( r-l < thresh ) {
           cormenQuicksort(l,q);
           cormenQuicksort(q+1,r);
           return;
	}

	System.out.println("recursion l " + l + " q " + q + " r " + r);

        ParQuickSort t1 = new ParQuickSort(l,q);
        ParQuickSort t2 = new ParQuickSort(q+1,r);
        concurrent( t1, t2 );

	return;
    }

}
