/** 
 * Recursion Threads
 *
 * see also FJTask by Lea
 *
 */

//package edu.unima.ky.parallel;

import java.io.*;
import java.util.*;

public class RecursionThreads extends Thread {

    private static int numw = 1000;
    private static Deque[] works = null;
    private static int wunit = 0;

    private static int numt = 4;
    private static RecursionThreads[] threads = null;
    private static int tcount = -1;
    private int myw = -1;

    private static boolean running = false;
    private boolean working = false;
    private static Random rand = new Random();

    public RecursionThreads() {
        this(numt);
    }

    public RecursionThreads(int number) {
        numt = number;
        if (numt <= 0) numt = 1;
        tcount++; myw = tcount;
        if ( (works == null) && (threads == null) ) {
           wunit = 0;
           works = new Deque[numt];
           for ( int i = 0; i < numt; i++ ) {
                 works[i] = new Deque(numw);
           }
           threads = new RecursionThreads[numt];
           threads[0] = this; 
           this.start();
           for ( int i = 1; i < numt; i++ ) {
                 RecursionThreads t = new RecursionThreads();
                 threads[i] = t;
                 t.start();
           }
           //System.out.println("Started " + numt + " Threads.");
        }
    }


    public boolean isWorking() {
        return working;
    }


    public void run() {
        running = true;
        RecursionTask w;
        Object o;
        while (running) {
            w = null;
            try { // search some work
              int i = myw; 
              while ( w == null && running ) { 
                  if (i == myw) { o = works[i].pop(100); }
                           else { o = works[i].get(100); }
                  if (o instanceof RecursionTask) {
                     w = (RecursionTask)o; 
                     w.setThread(this);
                     if (i != myw) {
                        System.out.println(myw + " has stolen from " + i); }
                  }
                  i++; if (i >= numt) i -= numt;
              }
            } catch (InterruptedException e) { running = false; }
            if ( w != null ) { 
               working = true;
               w.runit(); 
	       working = false;
            }
        }
    }


    public static void terminate() {
        RecursionThreads t = null;
        RecursionTask w = null;
        int i = numt-1;
        while ( i >= 0 ) {
              while ( !works[i].empty() ) {
                      try { sleep(100);
                      } catch (InterruptedException e) { }
              }
              i--;
        }
        //System.out.println(wunit + " work units processed.");
	running = false;
        i = numt-1;
        while ( i > 0 ) {
            try { 
                t = threads[i]; i--;
                while ( t.isWorking() ) {
		    sleep(100);
                }
                while ( t.isAlive() ) {
                        t.interrupt(); t.join(100);
                }
            } catch (InterruptedException e) { }
        }
        threads = null;
        works = null;
        tcount = -1;
    }


    public  void invoke(RecursionTask t) {
        int myt = Math.abs( rand.nextInt() % numt );
        t.setThread(threads[myt]);
        try {
            works[myt].push( t ); wunit++;
            t.waitDone(); 
        } catch (InterruptedException e) { }
    }


    public  void concurrent(RecursionTask t1, RecursionTask t2) {
        int myt = myw; 
        try {
            t1.setThread(threads[myt]);
            works[myt].push( t1 ); wunit++;
            t2.setThread(threads[myt]);
            works[myt].push( t2 ); wunit++; 
        } catch (InterruptedException e) { }
        RecursionTask t = null;
        while ( !t1.isDone() || !t2.isDone() ) {
	    Object o;
              try { 
                  o = works[myt].pop(100);
                  if (o instanceof RecursionTask) {
                     t = (RecursionTask)o; 
                     if (t != null) t.runit();
                  } else sleep(100);
              } catch (InterruptedException e) { }
        }
        try { 
            t1.waitDone(); t2.waitDone();
        } catch (InterruptedException e) { }
    }


    public  void concurrent(RecursionTask[] rt) {
        int myt = myw; 
        try {
            for (int i = 0; i < rt.length; i++) {
                rt[i].setThread(threads[myt]);
                works[myt].push( rt[i] ); wunit++;
            }
        } catch (InterruptedException e) { }
        RecursionTask t = null;
        Object o = null;
        boolean done = false;
        while ( !done ) {
	      done = true;
              for (int i = 0; i < rt.length; i++) {
                  done = done && rt[i].isDone();
              }
              if (done) break;
              try { 
                  o = works[myt].pop(100);
                  if (o instanceof RecursionTask) {
                     t = (RecursionTask)o; 
                     if (t != null) t.runit();
                  } else sleep(100);
              } catch (InterruptedException e) { }

        }
        try { 
            for (int i = 0; i < rt.length; i++) {
                rt[i].waitDone(); 
            }
        } catch (InterruptedException e) { }
    }

}

