/** 
 * Sequential QuickSort 
 *
 * see Sedgewick or Cormen+
 *
 */

//package edu.unima.ky.parallel;

import java.io.*;

public class SeqQuickSort {

    private int[] A;

    public SeqQuickSort(int[] A) {
        this.A = A;
    }

    public synchronized void sort() {
        cormenQuicksort(0,A.length-1);
        //sedgewickQuicksort(0,A.length-1);
	return;
    }

    private int partition(int l, int r) {
	// if (l >= r) return l;
	int x, t, i, j;
        x = A[l]; i = l-1; j = r+1;
        while (true) {
	    do { j--; } while ( A[j] > x );
	    do { i++; } while ( A[i] < x );
            if ( i < j ) {
               t = A[i]; A[i] = A[j]; A[j] = t; 
            } else return j;
        }
    }

    private void cormenQuicksort(int l, int r) {
	if (l >= r) return;
	int q = partition(l,r);
        // recursion
        cormenQuicksort(l,q);
        cormenQuicksort(q+1,r);
	return;
    }

    private void sedgewickQuicksort(int l, int r) {
	int v, t, i, j;
	if (l >= r) return;
        v = A[r]; i = l-1; j = r;
        do {
	    do { i++; } while ( A[i] < v );
	    do { j--; } while ( (A[j] > v) && (j > i) ); //-hk-
            t = A[i]; A[i] = A[j]; A[j] = t; 
	} while (j > i);
        A[j] = A[i]; A[i] = A[r]; A[r] = t;
        // recursion
	//	System.out.println("l = " + l + ", i = " + i + ", A[i] = " + A[i] + ", r = " + r);
        sedgewickQuicksort(l,i-1);
        sedgewickQuicksort(i+1,r);
	return;
    }

}
