/**
 * Sequential QuickSort Test using JUnit
 *
 */

//package edu.unima.ky.parallel;

//import junit.framework.*;
import java.io.*;
import java.util.*;

public class SeqQuickSortTest /*extends TestCase*/ {

   public static void main (String[] args) {
       //          junit.textui.TestRunner.run( suite() );
       new SeqQuickSortTest().testQuickSort2();
       new SeqQuickSortTest().testQuickSort4();
   }

    /*
   public SeqQuickSortTest(String name) {
          super(name);
   }

   public static Test suite() {
     TestSuite suite= new TestSuite(SeqQuickSortTest.class);
     return suite;
   }
    */

   private int[] A;

   private Random rand = new Random();
   private PrintWriter out = new PrintWriter(System.out);

   protected void setUp() {
   }

   protected void tearDown() {
   }

   protected void assertEquals(boolean a, boolean b) {
       if ( a == b ) return;
       System.out.println("expected " + a + " got " + b);
   }


   public void testQuickSort0() {
     int size = 0;
     A = new int[size];

     SeqQuickSort qs = new SeqQuickSort(A);
     qs.sort();
   }

   public void testQuickSort1() {
     int size = 1;
     A = new int[size];
     for (int i = 0; i < size; i++) {
	 A[i] = Math.abs(rand.nextInt() % size);
     }
     //printVec(A,out);

     SeqQuickSort qs = new SeqQuickSort(A);
     qs.sort();

     //printVec(A,out);
     for (int i = 0; i < size-1; i++) {
         assertEquals( (A[i] <= A[i+1]) ,true);
     }

   }

   public void testQuickSort2() {
     int size = 100;
     A = new int[size];
     for (int i = 0; i < size; i++) {
	 A[i] = Math.abs(rand.nextInt() % size);
     }
     printVec(A,out);

     SeqQuickSort qs = new SeqQuickSort(A);
     qs.sort();

     printVec(A,out);
     for (int i = 0; i < size-1; i++) {
         assertEquals( (A[i] <= A[i+1]) ,true);
     }

   }

   public void testQuickSort3() {
     int size = 1000;
     A = new int[size];
     for (int i = 0; i < size; i++) {
	 A[i] = Math.abs(rand.nextInt() % size);
     }

     SeqQuickSort qs = new SeqQuickSort(A);
     qs.sort();

     for (int i = 0; i < size-1; i++) {
         assertEquals( (A[i] <= A[i+1]) ,true);
     }
   }

   public void testQuickSort4() {
     int size = 1000;
     A = new int[size];
     for (int i = 0; i < size; i++) {
	 A[i] = Math.abs(rand.nextInt());
     }

     SeqQuickSort qs = new SeqQuickSort(A);
     qs.sort();

     for (int i = 0; i < size-1; i++) {
         assertEquals( (A[i] <= A[i+1]) ,true);
     }

   }

   public void testQuickSort5() {
     int size = 100000;
     A = new int[size];
     for (int i = 0; i < size; i++) {
	 A[i] = Math.abs(rand.nextInt() % size);
     }

     SeqQuickSort qs = new SeqQuickSort(A);
     qs.sort();

     for (int i = 0; i < size-1; i++) {
         assertEquals( (A[i] <= A[i+1]) ,true);
     }

   }

  /**
   * Prints a vector
   */
  static void printVec(int[] v, PrintWriter out) {
    out.println();
    out.println("Vector of " + v.length + " elements");
    out.print("( ");
    for (int i = 0; i<v.length; i++) { 
      if ((i%10)==0) { out.println(); out.print("  "); }
      out.print(v[i]+" ");
    }
    out.println();
    out.println(")");
    out.flush();
  }

}

